'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var MyLink = function MyLink(_ref) {
  var modal = _ref.modal,
      to = _ref.to,
      props = _objectWithoutProperties(_ref, ['modal', 'to']);

  var modalTo = to;
  if (modal) {
    if (typeof to === 'string') {
      modalTo = {
        pathname: to,
        state: { modal: true }
      };
    } else if ((typeof to === 'undefined' ? 'undefined' : _typeof(to)) === 'object') {
      modalTo = _extends({}, to, {
        state: _extends({}, to.state, {
          modal: true
        })
      });
    }
  }

  return _react2.default.createElement(_reactRouterDom.Link, _extends({}, props, { to: modalTo }));
};

exports.default = MyLink;
module.exports = exports['default'];