'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MySwitch = function (_React$Component) {
  _inherits(MySwitch, _React$Component);

  function MySwitch() {
    _classCallCheck(this, MySwitch);

    return _possibleConstructorReturn(this, (MySwitch.__proto__ || Object.getPrototypeOf(MySwitch)).apply(this, arguments));
  }

  _createClass(MySwitch, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        modal: this.props.modal
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _context = this.context,
          location = _context.location,
          previousLocation = _context.previousLocation;

      var modalLocation = location.state && location.state.modal;
      var switchLocation = (this.props.modal || !modalLocation ? location : previousLocation) || '/';
      return _react2.default.createElement(
        _reactRouterDom.Switch,
        { location: switchLocation },
        this.props.children
      );
    }
  }]);

  return MySwitch;
}(_react2.default.Component);

MySwitch.defaultProps = {
  modal: false
};


MySwitch.childContextTypes = {
  modal: _propTypes2.default.bool
};

MySwitch.contextTypes = {
  previousLocation: _propTypes2.default.object,
  location: _propTypes2.default.object
};

exports.default = MySwitch;
module.exports = exports['default'];