'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MyRoute = function (_React$Component) {
  _inherits(MyRoute, _React$Component);

  function MyRoute() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MyRoute);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MyRoute.__proto__ || Object.getPrototypeOf(MyRoute)).call.apply(_ref, [this].concat(args))), _this), _this.componentRender = function (props) {
      var _this$context = _this.context,
          ModalComponent = _this$context.ModalComponent,
          modal = _this$context.modal,
          closeModal = _this$context.closeModal;
      var _this$props = _this.props,
          component = _this$props.component,
          render = _this$props.render;

      var Component = component || render;
      return modal ? _react2.default.createElement(
        ModalComponent,
        { closeModal: closeModal },
        _react2.default.createElement(Component, _extends({}, props, { closeModal: closeModal }))
      ) : _react2.default.createElement(Component, props);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MyRoute, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          component = _props.component,
          render = _props.render,
          props = _objectWithoutProperties(_props, ['children', 'component', 'render']);

      var routeComponent = component ? this.componentRender : undefined;
      var routeRender = render ? this.componentRender : undefined;
      return _react2.default.createElement(_reactRouterDom.Route, _extends({}, props, { component: routeComponent, render: routeRender }));
    }
  }]);

  return MyRoute;
}(_react2.default.Component);

MyRoute.contextTypes = {
  modal: _propTypes2.default.bool,
  ModalComponent: _propTypes2.default.func,
  closeModal: _propTypes2.default.func
};

exports.default = MyRoute;
module.exports = exports['default'];